	list p=12f629

; manfred2801 (14.2.2004 Pauls 2. Geburtstag) 
;
; Ansteuerung einer Ampel mit PIC12F629 
;
; Taktquelle: 4MHz
;
;***********************************************************************
; Includedatei fr den 12F629 einbinden

	#include <P12f629.INC>

	ERRORLEVEL      -302    	;SUPPRESS BANK SELECTION MESSAGES

; Configuration festlegen:
; Power on Timer ein, kein Watchdog, int-Oscillator, kein Brown out
	__CONFIG	_MCLRE_OFF & _PWRTE_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_OFF


;**************************************************************
; Variablennamen vergeben
;
loops	Equ	0x22		; Zhler fr Warteschleife 
loops2	Equ	0x23		; Zhler fr Warteschleife 
loops3  Equ	0x24		; Zhler fr Warteschleife 

#define	Rot	GPIO, 0
#define Gelb	GPIO, 1
#define Gruen	GPIO, 2



;***********************************************************************
; Initialisierung
;
;***********************************************************************
Init
	; IO-Pins
	bcf	STATUS, RP0		; Bank 0
	clrf	GPIO			; aus!
	movlw	0x07
	movwf	CMCON			; alle Pins digital (nicht Comp)
	bsf	STATUS, RP0		; Bank 1
	movlw	B'00100000'		; input oder output (0=output)
	movwf	TRISIO			; festlegen
	bcf	STATUS, RP0		; Bank0

	; interner Taktgenerator
	bsf	STATUS, RP0		; Bank 1
	call	0x3FF
	movwf	OSCCAL			; 4-MHz-Kalibrierung
	bcf	STATUS, RP0		; Bank 0


;***********************************************************************
;Main 
;
;***********************************************************************
Main
	bcf	Rot
	bcf	Gelb
	bcf	Gruen

Schleife
	bsf	Gruen		; GRN
	call	Wait10s
	bcf	Gruen
	call	Wait
	call	Wait
	bsf	Gruen
	call	Wait
	call	Wait
	bcf	Gruen
	call	Wait
	call	Wait
	bsf	Gruen
	call	Wait
	call	Wait
	bcf	Gruen
	call	Wait
	call	Wait
	bsf	Gruen
	call	Wait
	call	Wait
	bcf	Gruen
	call	Wait
	call	Wait
	bsf	Gelb		; GELB
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	bcf	Gelb		; GELB
	bsf	Rot		; ROT
	call	Wait10s
	bsf	Gelb		; ROT/GELB
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	call	Wait
	bcf	Rot		
	bcf	Gelb		
	goto 	Schleife





;**********************************************************
; Warteschleife 10s
Wait10s
	movlw	D'40'		; 40x250ms = 10s
	movwf	loops3
Wai3
	call	Wait
	decfsz	loops3, F
	goto	Wai3
	retlw	0


;**********************************************************
; Warteschleife 250 ms
Wait
	movlw	D'250'		; 250 ms Pause (D'250')
	movwf	loops	

Wai
	movlw   .110           ; Zeitkonstante fr 1ms (.110)
        movwf   loops2
Wai2    nop                    ; 
        nop
        nop
        nop
        nop
        nop
        decfsz  loops2, F      ; 1 ms vorbei?
        goto    Wai2           ; nein, noch nicht
                               ;
        decfsz  loops, F       ; 250 ms vorbei?
        goto    Wai            ; nein, noch nicht
        retlw   0              ; das Warten hat ein Ende

	end




